define(["exports", "core/pubsubhub"], function (exports, _pubsubhub) {
  "use strict";

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.done = exports.name = undefined;

  function _asyncToGenerator(fn) {
    return function () {
      var gen = fn.apply(this, arguments);
      return new Promise(function (resolve, reject) {
        function step(key, arg) {
          try {
            var info = gen[key](arg);
            var value = info.value;
          } catch (error) {
            reject(error);
            return;
          }

          if (info.done) {
            resolve(value);
          } else {
            return Promise.resolve(value).then(function (value) {
              step("next", value);
            }, function (err) {
              step("throw", err);
            });
          }
        }

        return step("next");
      });
    };
  }

  const name = exports.name = "core/post-process";

  let doneResolver;
  const done = exports.done = new Promise(resolve => {
    doneResolver = resolve;
  });

  (0, _pubsubhub.sub)("plugins-done", (() => {
    var _ref = _asyncToGenerator(function* (config) {
      const result = [];
      if (Array.isArray(config.postProcess)) {
        const values = yield Promise.all(config.postProcess.filter(function (f) {
          return typeof f === "function";
        }).map(function (f) {
          return Promise.resolve(f(config, document));
        }));
        result.push(...values);
      }
      if (typeof config.afterEnd === "function") {
        result.push((yield Promise.resolve(config.afterEnd(config, document))));
      }
      doneResolver(result);
    });

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  })(), { once: true });
});
//# sourceMappingURL=post-process.js.map