define(["exports", "core/pubsubhub", "core/l10n"], function (exports, _pubsubhub, _l10n) {
  "use strict";

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.run = exports.name = undefined;

  function _asyncToGenerator(fn) {
    return function () {
      var gen = fn.apply(this, arguments);
      return new Promise(function (resolve, reject) {
        function step(key, arg) {
          try {
            var info = gen[key](arg);
            var value = info.value;
          } catch (error) {
            reject(error);
            return;
          }

          if (info.done) {
            resolve(value);
          } else {
            return Promise.resolve(value).then(function (value) {
              step("next", value);
            }, function (err) {
              step("throw", err);
            });
          }
        }

        return step("next");
      });
    };
  }

  const name = exports.name = "w3c/abstract";

  let run = exports.run = (() => {
    var _ref = _asyncToGenerator(function* (conf) {
      const abs = document.getElementById("abstract");
      if (!abs) {
        (0, _pubsubhub.pub)("error", `Document must have one element with \`id="abstract"`);
        return;
      }
      abs.classList.add("introductory");
      let abstractHeading = document.querySelector("#abstract>h2");
      if (abstractHeading) {
        return;
      }
      abstractHeading = document.createElement("h2");
      abstractHeading.innerText = _l10n.l10n[_l10n.lang].abstract;
      abs.insertAdjacentElement("afterbegin", abstractHeading);
    });

    return function run(_x) {
      return _ref.apply(this, arguments);
    };
  })();
});
//# sourceMappingURL=abstract.js.map